/*
   CS 202
   st.cpp: example of derived class, member function overriding,
   and pointer usage with derived-class objects.
*/
#include <iostream.h>
#include <string.h>

class people {				// base class
public:
	people(void)
	{ cout << "people constructor called.\n"; }
	void attitude_is(void)
	{ cout << "The people don't care.\n"; }
};

class student : public people {		// derived class
public:
	student(void)			// constructor
	{  cout << "student constructor called.\n";
	   strcpy(name,"Students");
	   strcpy(attitude,"is hard");
	}
	void attitude_is(void) 		// override base-class function
	{ cout << name << " think CS "<< attitude << ".\n" ;}
protected:
	char name[20], attitude[20];	// add new data members
};

main()	// driver program 
{
	people JohnDoe, *peoptr;	// base objects and pointers
	student Fred, *stptr;		// derived objects and pointers
	
	JohnDoe.attitude_is();		// show attitudes of objects
	Fred.attitude_is();

	peoptr = &JohnDoe;		// use base-class pointer
	peoptr->attitude_is();		// with base-class object

	stptr = &Fred;			// use derived-class pointer
	stptr->attitude_is();		// with derived-class object

	peoptr = &Fred;			// use base-class pointer
	peoptr->attitude_is();		// with derived-class object
					// (uses base-class members)
	stptr = static_cast< student * > (peoptr);	
	stptr->attitude_is();		// cast base-class pointer
					// to derived-class pointer
					// (uses derived-class members)
}
